﻿using DataSetRelationsForeignKeyUniqueKey.Common;
using Microsoft.Data.SqlClient;
using System.Data;
using System.Data.Common;

//===========================================================
// Подробное описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//===========================================================



namespace DataSetRelationsForeignKeyUniqueKey.PashaCode
{
    internal class ConnectDatabase
    {

        private static string ConnectionString
        {
            get
            {
                var sb = new SqlConnectionStringBuilder
                {
                    DataSource = @"(LocalDB)\MSSQLLocalDB",
                    IntegratedSecurity = true,
                    InitialCatalog = "Catalog",
                    Pooling = true
                };

                return sb.ConnectionString;
            }
        }

        private static SqlDataAdapter GetAdapter(SqlConnection connection, string querystring, List<SqlParameter>? parameters = null)
        {
            SqlCommand command = new(querystring, connection);

            if (parameters != null)
            {
                foreach (SqlParameter p in parameters)
                {
                    command.Parameters.Add(p);
                }
            }

            SqlDataAdapter adapter = new()
            {
                SelectCommand = command,
                UpdateCommand = command,
                InsertCommand = command,
                DeleteCommand = command
            };
            connection.Open();

            return adapter;
        }

        public static DataSet GetData(string querystring, List<SqlParameter>? parameters = null)
        {
            using SqlConnection connection = new(ConnectionString);
            SqlDataAdapter adapter = GetAdapter(connection, querystring, parameters);

            DataSet dataSet = new("Catalog");

            // Карта соответствия названий таблиц набора DataSet и базы данных.
            adapter.TableMappings.Add("Table", Constants.ParentTableName);
            adapter.TableMappings.Add("Table1", Constants.ChildTableName);
            adapter.Fill(dataSet);

            return dataSet;
        }


        public static void SaveData(DataTable dt, string querystring, List<SqlParameter>? parameters = null)
        {
            using SqlConnection connection = new(ConnectionString);
            SqlDataAdapter adapter = GetAdapter(connection, querystring, parameters);

            int i = adapter.Update(dt);
            // Звук успешного обновления - для режима тестирования.
            if (i > 0) Console.Beep(3000, 100);
        }
    }
}
